##################################################################
# ball and cilinder
# sphere
sphere(x,t;v,r,x0) = dist(x,x0+v*t)-r
# cilinder
cilinder(x,t;v,r,x0) = dist(x[1:2],x0[1:2]+v[1:2]*t)-r
#################################################################
nmax = 100
start = [0,1/2,0]
cilinder_radius = 1/10; #xcil = 1-cilinder_radius-1/10
cilinder_velocity = [0.5,-0.7,0.] #
cilinder_position = [0.1,1.1,0.]
cil(x,t) = cilinder(x,t;v=cilinder_velocity,r=cilinder_radius,x0=cilinder_position) #
#############################
ball_radius = 0.2
ball_velocity = [-0.1,0.3,0.6]
ball_position = [0.7,0.3,0]
ball(x,t) = sphere(x,t;v=ball_velocity,r=ball_radius,x0=ball_position)
#train1D(x,t;pos=nmax/2,width = 2nmax/100,tin=0,tend=nmax/3)
#obstacles(x,t) = min(static_circle(x,t,r=nmax/10),boy2D(x,t),wall(x,t),moving_circle(x,t,r = nmax/25, x0 = 1,y0 = 1, vel=[0,1]),circle_in_circles(x,t,r=nmax/50, x0=nmax/2,y0 = nmax/2, R=nmax/5,ω = 0.1))
g(x,t) = min(cil(x,t),ball(x,t))
@time G,V = dfmm(initSet = [start], obstacle=g);
T = G.T
#
paint(T[:,:,round(Int,nmax/2)])